#! /bin/sh
# PCP QA Test No. 649
# Testing MMV client flags behaviour
#
# Copyright (c) 2010 Aconex.  All Rights Reserved.
#

seq=`basename $0`
echo "QA output created by $seq"

# get standard filters
. ./common.product
. ./common.filter
. ./common.check

rm -f $seq.out
if [ $PCP_VER -lt 30600 ]
then
    ln $seq.out.1 $seq.out || exit 1
else
    ln $seq.out.2 $seq.out || exit 1
fi

status=1
username=`id -u -n`
done_clean=false
MMV_STATS_DIR="$PCP_TMP_DIR/mmv"

_cleanup()
{
    if $done_clean
    then
	:
    else
	_restore_config $PCP_PMCDCONF_PATH
	if [ -d $tmp.mmv.dir ]
	then
	    $sudo rm -fr "$MMV_STATS_DIR"
	    $sudo mv $tmp.mmv.dir $MMV_STATS_DIR
	fi
	$sudo $PCP_RC_DIR/pcp restart | _filter_pcp_start
	_wait_for_pmcd
	_wait_for_pmlogger
	if $install_on_cleanup
	then
	    ( cd $PCP_PMDAS_DIR/mmv; $sudo ./Install <$tmp.input >/dev/null 2>&1 )
	else
	    ( cd $PCP_PMDAS_DIR/mmv; $sudo ./Remove </dev/null >/dev/null 2>&1 )
	fi
	rm -f $tmp.*
	done_clean=true
    fi
    exit $status
}

install_on_cleanup=false
pminfo mmv >/dev/null 2>&1 && install_on_cleanup=true

trap "_cleanup" 0 1 2 3 15

# for QA the default install for mmv PMDA is as a dso, not a daemon
#
cat <<End-of-File >$tmp.input
b
dso
End-of-File

_filter()
{
    sed \
	-e '/^mmv.test.interval/d' \
	-e '/^mmv.interval/d' \
    #
}

# real QA starts here
home="$PCP_PMDAS_DIR"
iam=mmv
cd "$home/$iam"
unset ROOT MAKEFLAGS

# copy the pmcd config file to restore state later.
_save_config $PCP_PMCDCONF_PATH
# move the MMV directory to restore contents later.
[ -d $MMV_STATS_DIR ] && $sudo mv -f $MMV_STATS_DIR $tmp.mmv.dir

# start from a known starting point
$sudo ./Remove >/dev/null 2>&1

# create a directory we can write and pcp group can read
$sudo mkdir -m 755 "$MMV_STATS_DIR"
$sudo chown $username "$MMV_STATS_DIR"
$sudo chgrp pcp "$MMV_STATS_DIR"

echo
echo "=== $iam agent installation ==="
$sudo ./Install </dev/null >$tmp.out 2>&1
_filter_pmda_install <$tmp.out

$here/src/mmv_genstats

echo
echo "=== Listing with a valid process and with prefix ==="
$here/src/mmv_poke -p $$ -f process "$MMV_STATS_DIR/test"
pmprobe -v mmv | _filter

echo "=== Listing with a valid process and without prefix ==="
$here/src/mmv_poke -p $$ -f noprefix "$MMV_STATS_DIR/test"
pmprobe -v mmv | _filter

echo "=== Listing without a valid process ==="
$here/src/mmv_poke -p 4294967295 -f process "$MMV_STATS_DIR/test"
pmprobe -v mmv | _filter

echo
echo "=== remove $iam agent ==="
$sudo ./Remove >$tmp.out 2>&1
_filter_pmda_remove <$tmp.out

echo
echo "=== $iam agent re-installation ==="
$sudo ./Install <$tmp.input >$tmp.out 2>&1
_filter_pmda_install <$tmp.out

status=0
exit
